    .model small,c
    .386
    .stack

    include support.asm
    include iddevice.inc

    iddevice PROTO baseport:WORD, fslave:WORD, npdest:WORD

.data
    resPrimaryMaster    dw 0
    resPrimarySlave     dw 0
    resSecondaryMaster  dw 0
    resSecondarySlave   dw 0
    buffer              dw 256 dup(0),0
.code
.startup

    ; Dump buffer as test.
    ;invoke iddevice, IOBASE1, 0, ADDR buffer
    ;invoke dumpmem, ds, ADDR buffer, 16
    ;call waitkey
    ;invoke dumpmem, ds, ADDR buffer, 16
    ;call waitkey

    invoke iddevice, IOBASE1, 0, ADDR buffer
    mov resPrimaryMaster, ax
    invoke iddevice, IOBASE1, 1, ADDR buffer
    mov resPrimarySlave, ax
    invoke iddevice, IOBASE2, 0, ADDR buffer
    mov resSecondaryMaster, ax
    invoke iddevice, IOBASE2, 1, ADDR buffer
    mov resSecondarySlave, ax

    print "Primary Master - "
    .IF resPrimaryMaster == ID_ERROR_NO_DEVICE
      ; This error value normally indicates that there are
      ; no devices connected to the ATA interface channel
      ; (or that the program is running under a version of
      ; Windows that blocks access to the Command/Control
      ; Block registers).
      print "Device not detected",nl
    .ELSEIF resPrimaryMaster == ID_ERROR_TIMEOUT_BSY
      print "Timeout device busy",nl
    .ELSEIF resPrimaryMaster == ID_ERROR_TIMEOUT_NODRQ
      ; If the other device connected to the channel is
      ; present, then this error value normally indicates
      ; that the target device is not present.
      .IF resPrimarySlave
        print "Unexpected error",nl
      .ELSE
        print "Device not detected",nl
      .ENDIF
    .ELSEIF resPrimaryMaster == ID_ERROR_UNEXPECTED
      print "Unexpected error",nl
    .ELSEIF resPrimaryMaster == -1
      print "ATAPI device detected",nl
    .ELSE
      print "ATA device detected",nl
    .ENDIF

    print "Primary Slave - "
    .IF resPrimarySlave == ID_ERROR_NO_DEVICE
      print "Device not detected",nl
    .ELSEIF resPrimarySlave == ID_ERROR_TIMEOUT_BSY
      print "Timeout device busy",nl
    .ELSEIF resPrimarySlave == ID_ERROR_TIMEOUT_NODRQ
      .IF resPrimaryMaster
        print "Unexpected error",nl
      .ELSE
        print "Device not detected",nl
      .ENDIF
    .ELSEIF resPrimarySlave == ID_ERROR_UNEXPECTED
      print "Unexpected error",nl
    .ELSEIF resPrimarySlave == -1
      print "ATAPI device detected",nl
    .ELSE
      print "ATA device detected",nl
    .ENDIF

    print "Secondary Master - "
    .IF resSecondaryMaster == ID_ERROR_NO_DEVICE
      print "Device not detected",nl
    .ELSEIF resSecondaryMaster == ID_ERROR_TIMEOUT_BSY
      print "Timeout device busy",nl
    .ELSEIF resSecondaryMaster == ID_ERROR_TIMEOUT_NODRQ
      ; If the other device connected to the channel is
      ; present, then this error value normally indicates
      ; that the target device is not present.
      .IF resSecondarySlave
        print "Unexpected error",nl
      .ELSE
        print "Device not detected",nl
      .ENDIF
    .ELSEIF resSecondaryMaster == ID_ERROR_UNEXPECTED
      print "Unexpected error",nl
    .ELSEIF resSecondaryMaster == -1
      print "ATAPI device detected",nl
    .ELSE
      print "ATA device detected",nl
    .ENDIF

    print "Secondary Slave - "
    .IF resSecondarySlave == ID_ERROR_NO_DEVICE
      print "Device not detected",nl
    .ELSEIF resSecondarySlave == ID_ERROR_TIMEOUT_BSY
      print "Timeout device busy",nl
    .ELSEIF resSecondarySlave == ID_ERROR_TIMEOUT_NODRQ
      .IF resSecondaryMaster
        print "Unexpected error",nl
      .ELSE
        print "Device not detected",nl
      .ENDIF
    .ELSEIF resSecondarySlave == ID_ERROR_UNEXPECTED
      print "Unexpected error",nl
    .ELSEIF resSecondarySlave == -1
      print "ATAPI device detected",nl
    .ELSE
      print "ATA device detected",nl
    .ENDIF

    print nl,"Press any key normal key to exit..."
    call waitkey

.exit

iddevice proc baseport:WORD, fslave:WORD, npdest:WORD

    ; The fAtapi code is a hack to allow detection of
    ; ATAPI devices.

    LOCAL dhVal:BYTE, scVal:BYTE, fAtapi:BYTE

    ; Get and save the value from the Device/Head Register.
    ;
    mov dx, baseport
    add dx, DEVICE_HEAD_OFFSET
    in  al, dx
    mov dhVal, al
    invoke delay, 600

    ; Set or clear the Device/Head Register DEV bit
    ; (set for slave, clear for master) and write the
    ; value back to the register.
    ;
    .IF fslave
      or  al, DEVICE_HEAD_DEV_MASK
    .ELSE
      and al, not DEVICE_HEAD_DEV_MASK
    .ENDIF
    out dx, al

    invoke delay, 600

    ; Determine if the Sector Count Register exists by writing
    ; a test value to the register and reading the value back.
    ; If the register does not exist, indicating that no devices
    ; are connected to the channel, exit and return the
    ; appropriate error code.
    ;
    mov dx, baseport
    add dx, SECTOR_COUNT_OFFSET
    in  al, dx
    mov scVal, al
    invoke delay, 600
    not al
    mov cl, al
    out dx, al
    invoke delay, 600
    in  al, dx
    .IF al != cl
      mov ax, ID_ERROR_NO_DEVICE
      jmp fini
    .ENDIF
    mov al, scVal
    out dx, al
    invoke delay, 600

    ; Wait for the device to indicate that it is not busy.
    ; If the Device Busy bit in the Alternate Status Register
    ; is not clear within the delay period, exit and return
    ; the appropriate error code.
    ;
    mov cx, 10
    mov dx, baseport
    add dx, ALT_STATUS_OFFSET
    .WHILE cx
      in  al, dx
      .IF al & STATUS_BSY_MASK
        invoke delay, 600
      .ELSE
        .BREAK
      .ENDIF
      sub cx, 1
    .ENDW
    .IF cx == 0
      mov ax, ID_ERROR_TIMEOUT_BSY
      jmp fini
    .ENDIF

    mov fAtapi, 0

    ; Send the ATA Identify Device command to the Command Register.
    ; For an ATAPI device, this command will return with the error
    ; bit in the Alternate Status Register set and the ATAPI
    ; signature in the cylinder high and cylinder low registers.
    ;
    mov dx, baseport
    add dx, COMMAND_OFFSET
    mov al, ATA_IDENTIFY_DEVICE
    out dx, al
    invoke delay, 600

    ; Check for the ATAPI signature, and send the ATAPI
    ; Identify Device command if it is present.
    ;
    mov dx, baseport
    add dx, CYL_HIGH_OFFSET
    in  al, dx
    mov ah, al
    mov dx, baseport
    add dx, CYL_LOW_OFFSET
    in  al, dx
    .IF ah == ATAPI_SIGNATURE_HIGH && al == ATAPI_SIGNATURE_LOW

      inc fAtapi

      ; Wait for the device to indicate that it is not busy.
      ; If the Device Busy bit in the Alternate Status Register
      ; is not clear within the delay period, exit and return
      ; the appropriate error code.
      ;
      mov cx, 10
      mov dx, baseport
      add dx, ALT_STATUS_OFFSET
      .WHILE cx
        in  al, dx
        .IF al & STATUS_BSY_MASK
          invoke delay, 600
        .ELSE
          .BREAK
        .ENDIF
        sub cx, 1
      .ENDW
      .IF cx == 0
        mov ax, ID_ERROR_TIMEOUT_BSY
        jmp fini
      .ENDIF

      ; Send the ATAPI Identify Device command.
      ;
      mov dx, baseport
      add dx, COMMAND_OFFSET
      mov al, ATAPI_IDENTIFY_DEVICE
      out dx, al
      invoke delay, 600
    .ENDIF

    ; Wait for the device to clear the Device Busy bit in the
    ; Alternate Status Register and set the Data Request bit.
    ; If the device does not do so the delay period, exit and
    ; return the appropriate error code.
    ;
    mov cx, 5
    mov dx, baseport
    add dx, ALT_STATUS_OFFSET
    .WHILE cx
      in  al, dx
      and al, STATUS_BSY_MASK or STATUS_DRQ_MASK
      .IF al != STATUS_DRQ_MASK
        invoke delay, 600
      .ELSE
        .BREAK
      .ENDIF
       sub cx, 1
    .ENDW
    .IF cx == 0
      mov ax, ID_ERROR_TIMEOUT_NODRQ
      jmp fini
    .ENDIF

    ; If the last command returned an error, then
    ; exit and return the appropriate error code.
    ;
    mov dx, baseport
    add dx, ALT_STATUS_OFFSET
    in  al, dx
    .IF al & STATUS_ERR_MASK
      mov ax, ID_ERROR_UNEXPECTED
      jmp fini
    .ENDIF

    ; Read the contents of the device's sector buffer
    ; into the destination buffer and set the return
    ; value for no error.
    ;
    push ds
    pop es
    mov di, npdest
    mov dx, baseport
    add dx, DATA_OFFSET
    cld
    mov cx, 256
    rep insw

    xor ax, ax
    .IF fAtapi
      mov ax, -1
    .ENDIF

  fini:

    ; Restore the Device/Head Register.
    ;
    push ax
    mov al, dhVal
    mov dx, baseport
    add dx, DEVICE_HEAD_OFFSET
    out dx, al
    pop ax

    ret
iddevice endp

end
